<?php
if (!class_exists( 'PressPayTransaction' )) {
  class PressPayTransaction {
    public $id;
    public $press_pay_customer_id;
    public $amount;
    public $type;
    public $created_at;
    public $updated_at;
    public $test;

    public function __construct( $params = array() ) {
      DebugModel::debug("PressPayTransaction::__construct");

      $default_vals = array(
        'id'                    => false,
        'press_pay_customer_id' => '',
        'amount'                => '',
        'type'                  => '',
        'created_at'            => '',
        'updated_at'            => '',
      );

      $params = array_merge( $default_vals, $params );

      $this->press_pay_customer_id = $params['press_pay_customer_id'];
      $this->amount                = $params['amount'];
      $this->type                  = $params['type'];
      $this->created_at            = $params['created_at'];
      $this->updated_at            = $params['updated_at'];
    }

    public function save() {
      global $wpdb;
      $data = array(
        'press_pay_customer_id' => $this->press_pay_customer_id,
        'type'                  => $this->type,
        'amount'                => $this->amount,
        'updated_at'            => current_time( 'mysql' ),
        'test'                  => true,
      );

      if ($this->id) {
        $success = $wpdb->update(
          PRESS_PAY_TRANSACTION_TABLE, $data, array( 'id' => $this->id )
        );
      } else {
        $data['created_at'] = current_time( 'mysql' );
        $success = $wpdb->insert( PRESS_PAY_TRANSACTION_TABLE, $data );
        $this->id = $wpdb->insert_id;
      }
      return( $success );
    }

    public function event( $event ) {
      DebugModel::debug( 'PressPayTransaction::event()' );
      $customer = PressPayCustomer::find_by_stripe_customer_id( $event->data->object->customer );
      $transaction = new PressPayTransaction( array(
        'press_pay_customer_id' => $customer->id,
        'amount' => $event->data->object->amount,
        'type' => $event->type,
      ));
      if (!$transaction->save()) DebugModel::debug( "could not save transaction event" );
    }
  }
}
?>
