<div class="wrap">
  <h2>Stripe Settings</h2>
  <?php
  // Show the upgrade button if they haven't already paid.
  if (!isset($stripe_options['payment']) || $stripe_options['payment'] !== 'paid') {
    include( STRIPE_BASE_DIR . '/app/view/admin/upgrade_section.php' );
  }
  ?>
  <form id="stripe_settings_form" method="post" action="options.php">
    <?php settings_fields('stripe_settings_group'); ?>
    <h3>Credit Card Processing</h3>
    <table id="stripe_mode" class="form-table">
    <?php
      $heading = 'Select mode of opertation:';
      $key = 'test_mode';
      $option1 = 'Test Mode';
      $option2 = 'Live Mode';
      include( STRIPE_BASE_DIR . '/app/view/admin/radio_button_option.php' );
    ?>
    </table>
    <h3>Stripe API Keys</h3>
    <table id="stripe_keys" class="form-table">
      <?php // Test Keys
        $heading = 'Test Secret';
        $key     = 'test_secret_key';
        $label   = 'Paste your secret test key.';
        include( STRIPE_BASE_DIR . '/app/view/admin/text_option.php' );
        $heading = 'Test Publishable';
        $key     = 'test_publishable_key';
        $label   = 'Paste your publishable test key here.';
        include( STRIPE_BASE_DIR . '/app/view/admin/text_option.php' );
        if (isset($stripe_options['payment']) && ($stripe_options['payment'] == 'paid')){
          // Live Keys
          $heading = 'Live Secret';
          $key     = 'live_secret_key';
          $label   = 'Paste your live secret key.';
          include( STRIPE_BASE_DIR . '/app/view/admin/text_option.php' );
          $heading = 'Live Publishable';
          $key     = 'live_publishable_key';
          $label   = 'Paste your live publishable key here.';
          include( STRIPE_BASE_DIR . '/app/view/admin/text_option.php' );
        }
      ?>
        <input id = "stripe_settings[payment]"
            name  = "stripe_settings[payment]"
            type  = "<?php echo( ADMIN_TEST ? 'text' : 'hidden' ); ?>"
            class = "regular-text"
            value = "<?php echo( $stripe_options['payment'] ); ?>">
    </table>
    <table class="form-table <?php echo( ADMIN_TEST ? '' : 'hidden' ); ?>">
      <tbody>
        <?php
          $heading = 'Allow Recurring';
          $key     = 'recurring';
          $label   = 'Allow Recurring Payments?';
          include( STRIPE_BASE_DIR . '/app/view/admin/checkbox_option.php' );
          $heading = 'One Time Sign-Up Fee';
          $key     = 'one_time_fee';
          $label   = 'charge a signup fee if checked';
          include( STRIPE_BASE_DIR . '/app/view/admin/checkbox_option.php' );
          $heading = 'Fee Amount';
          $key     = 'fee_amount';
          $label   = '';
          include( STRIPE_BASE_DIR . '/app/view/admin/text_option.php' );
        ?>
      </tbody>
    </table>
    <table id="sift_science_keys" class="form-table <?php echo( ADMIN_TEST ? '' : 'hidden' ); ?>">
      <th><h3>Sift Science API Keys</h3></th>
      <?php
        $heading = 'Sandbox Jabascript Snippet Key';
        $key     = 'sandbox_sift_science_js';
        $label   = 'Paste your Sift Science Sandbox Jabascript Snippet Key';
        include( STRIPE_BASE_DIR . '/app/view/admin/text_option.php' );
        $heading = 'Sandbox REST API Key';
        $key = 'sandbox_sift_science_rest';
        $label = 'Paste your Sift Science Sandbox REST API Key';
        include( STRIPE_BASE_DIR . '/app/view/admin/text_option.php' );
      ?>
    </table>
    <p class="submit">
      <input id    = "submit_stripe_options"
             type  = "submit"
             class = "button-primary"
             value = "Save Options" />
    </p>
  </form>
</div>
